BURPVI

BURPVI

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Driver for B+R controls based on the PVI software from Bernecker+Rainer. The driver communicates with PVI. For example system 2000 family (2003, 2005 etc.), Acopos, X20 system, Automation PC, PowerPanel etc. ...

The driver supports spontaneous operation with hysteresis and online import of multidimensional arrays and arrays with a start index <> 0.

Coupling: Serial, Ethernet

Protocol: PVI

The BUR-PVI driver replaces the BUR20032 driver. The addressing of these two drivers is not compatible with each other as the BUR20032 driver addresses the PVI items via an allocation file and the BUR-PVI saves the addressing directly via properties in the V-DLL. The driver is symbol-oriented.

attention Attention

Addressing of one-dimensional arrays:

If one-dimensional rays are addressed with a start index <> 0, a comma must be attached to the index. For details see: Documentation B&R.

For example: zenon[3,]


BURPVI - Data sheet

BURPVI -> BURPVI - Data sheet

General: |
Driver file name | BURPVI.exe
Driver description | BR-PVI driver
PLC types | All Bernecker and Rainer PLCs which can use the PVI communication like System 2000 family (2003, 2005 etc), Acopos, X20 System, AutomationPC, PowerPanel and others.
PLC manufacturer | Bernecker + Rainer;

Driver supports: |
Protocol | PVI;
Addressing: address based | -
Addressing: name based | x
Spontaneous communication | x
Polling communication | x
Online browsing | x
Offline browsing | x
Real-time capable | -
Blockwrite | -
Modem capable | -
Serial logging | -
RDA numerical | -
RDA String | -

Prerequisites: |
Hardware PC | RS 232 interface or Standard network card
Software PC | PVI software necessary, also under Windows CE. PC setup can be found on installation DVD.
Hardware PLC | -
Software PLC | -
Requires v-dll | x

Platforms: |
Operating systems | Windows CE 5.0, CE 6.0; Windows XP, Vista, 7, Server 2003, Server 2008/R2;
CE platforms | x86;


Driver history

BURPVI -> Driver history

Date | Driver version | Change
26.01.10 | 1400 | Driver was created newly
14.01.10 | 1500 | Fixed error at the configuration
05.03.10 | 1600 | Adjusted to PVI 3.0
17.03.10 | 1700 | Revised dialogs


Requirements

BURPVI -> Requirements

This chapter contains information on the requirements that are necessary for use of this driver.


PC

BURPVI -> Requirements -> PC

PVI software from Bernecker+Rainer.


PLC

BURPVI -> Requirements -> PLC


Configuration

BURPVI -> Configuration

In this chapter you will learn how to use the driver in a project and which settings you can change.

info Info

Find out more about further settings for zenon variables in the chapter Variables of the online manual.


Creating a driver

BURPVI -> Configuration -> Creating a driver

In order to create a new driver:

  • Right-click on Driver in the Project Manage and select Driver new in the context menu.
  • In the following dialog the control system offers a list of all available drivers.

  • Select the desired driver and give it a name:
    • The driver name has to be unique, i.e. if one and the same driver is to be used several times in one project, every time a new name has to be given each time.
    • The driver name is part of the file name. Therefore it may only contain characters which are supported by the operating system. Invalid characters are replaced by an underscore (_).
    • Attention: This name cannot be changed later on.
  • Confirm the dialog with OK. In the following dialog the single configurations of the drivers are defined.
  • Only the respective required drivers need to be loaded for a project. Later loading of an additional driver is possible without problems.

info Info

For new projects and for existing projects which are converted to version 6.21 or higher, the following drivers are created automatically:

  • Internal
  • MathDr32
  • SysDrv.


Settings in the driver dialog

BURPVI -> Configuration -> Settings in the driver dialog

You can change the following settings of the driver:


General

BURPVI -> Configuration -> Settings in the driver dialog -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Parameters

Description

Mode

Allows to switch between hardware mode and simulation mode

  • Hardware:

    A connection to the control is established.

  • Simulation static

    No communication between to the control is established, the values are simulated by the driver. In this modus the values remain constant or the variables keep the values which were set by zenon Logic. Each variable has its own memory area, e.g. two variables of the type marker with offset 79 can have different values in the Runtime and do not influence each other. Exception: The simulator driver.

  • Simulation - counting

    No communication between to the control is established, the values are simulated by the driver. In this modus the driver increments the values within a value range automatically.

  • Simulation - programmed

    N communication is established to the PLC. The values are calculated by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in a zenon Logic Runtime which is integrated in the driver. For details see chapter Driver simulation.

Keep update list in the memory

Variables which were requested once are still requested from the control even if they are currently not needed.
This has the advantage that e.g. multiple screen switches after the screen was opened for the first time are executed faster because the variables need not be requested again. The disadvantage is a higher load for the communication to the control.

Output can be written

Active: Outputs can be written.

Inactive: Writing of outputs is prevented.

Note: Not available for every driver.

Variable image remanent

This option saves and restores the current value, time stamp and the states of a data point.

Fundamental requirement: The variable must have a valid value and time stamp.

The variable image is saved in mode hardware if:

  • one of the states S_MERKER_1(0) up to S_MERKER8(7), REVISION(9), AUS(20) or ERSATZWERT(27) is active

The variable image is always saved if:

  • the variable is of the object type Driver variable
  • the driver runs in simulation mode. (not programmed simulation)

The following states are not restored at the start of the Runtime:

  • SELECT(8)
  • WR-ACK(40)
  • WR-SUC(41)

The mode Simulation - programmed at the driver start is not a criterion in order to restore the remanent variable image.

Stop at the Standby Server

Setting for redundancy at drivers which allow only on communication connection. For this the driver is stopped at the Standby Server and only started at the upgrade.

Attention: If this option is active, the gapless archiving is no longer guaranteed.

Active: Sets the driver at the not-process-leading Server automatically in a stop-like state. In contrast to stopping via driver command, the variable does not receive status switched off but an empty value. This prevents that at the upgrade to the Server irrelevant values are created in the AML, CEL and Historian.

Global Update time

Active: The set Global update time in ms is used for all variables in the project. The priority set at the variables is not used.
Inactive: The set priorities are used for the individual variables.

Priority

Here you set the polling times for the individual priorities. All variables with the according priority are polled in the set time. The allocation is taken place for each variable separately in the settings of the variable properties.
The communication of the individual variables are graduated in respect of importance or necessary topicality using the priorities. Thus the communication load is distributed better.

Update time for cyclical driver

The following applies for cyclical drivers:

For Set value, Advising of variables and Requests, a read cycle is immediately triggered for all drivers - regardless of the set update time. This ensures that the value is immediately available for visualization after writing. Update times can therefore be shorter than pre-set for cyclical drivers.


Global settings

BURPVI -> Configuration -> Settings in the driver dialog -> Global settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

General settings for the PVI communication are set in the Global Settings tab. These settings are true for all connections which are available in the driver.

Parameters

Description

Configuration file

File in which the configuration of connections and the global settings are saved. Click on ... in order to open the Windows Explorer.

Please note the hints in chapter: Configuration file in redundant operation.

Use PVI event mode

Active: All PVI variables are requested via event mode (PVI command AT=rwe HY=0).

Inactive: PVI variables are read cyclically with the setting of the global update time (AT=rw, RF=global update time in ms).

PVI communication timeout [s]

Timeout or PVI communication in seconds.
PviInitialize (dwTimeout, …)

Enable Remote Connection

Active: Connection to a remote PVI system via TCP/IP is established. The communication takes place exclusively via this gateway. A local PVI installation is always necessary.

In addition to the settings at the driver, you must configure the setting for the remote communication via TCP/IP at the PVI itself (PVI Monitor/Manager) - locally and at the remote system.

Computer name or IP address

Computer name or IP address on which the remote PVI system is installed and runs.

TCP/IP port number

TSP/IP port number of the remote PVI system.

Note: Any firewall that may be present must be configured so that the target port can be reached.

Online import options for arrays and structure variables

Options for the online import of array variables and structure variables.

Map array elements on driver object Type "Array as whole"

Active: At the import of array elements select Driver object typesRead in a request - exception for arrays in structures.

Map structure elements on driver object Type "Array as whole"

Active: At the import of array elements select Driver object typesRead in a request - also for arrays in structures.

Create one variable per array/structure item

Active: Only individual variables are created and no nodes are displayed.

Default setting.

Create one variable representing the whole array/structure (block arrays)

Active: For arrays and structures, only block variables are created, but no variables that represent individual variables of structures/arrays. This option has no influence on top level variables.

Create both - ensure that you use a suffix for block arrays to avoid import errors

Active: For arrays and structures, both individual elements and blocks that represent the whole structure are represented.

Suffix for block arrays

Suffix for the zenon names of variables that were created as block array - variables that represent a whole structure or complete array.

Array as a whole

With this all elements of the driver object type Array as whole are mapped. All elements of this object type are no longer read in the event that a value changes, but polled cyclically. The driver always reads in the whole array as a block.

A block array is a large variable in zenon that reads a complete block from the PLC. Many individual arrays are therefore read as a single array.


Connections

BURPVI -> Configuration -> Settings in the driver dialog -> Connections

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

On this tab you carry out the settings for the connection. You can create any number of connections in the driver. All connections use the global settings which are defined on tab General Settings.

Parameters

Description

Connection file

Storage location for the configuration file in which the connection and the global setting is saved. The file is set in tab General Settings.

Connections

List of available connections.

New

Adds new entry to the list. Settings are carried out in the field to the right of the list.

Delete

Deletes selected entry from the list.

Edit

Makes it possible to configure the selected entry. The area to the right of the list for editing the connection is activated.
Attention! The driver dialog cannot be closed in editing mode. Only once the editing mode has been left using Save or Cancel can you close the driver dialog.

Edit connection

Edit connection settings

Adress and name

Address and name

Net address

Net address of the connection for the allocation of variables.
Attention! If you change the net address here, you must also change the net address of all other variables of the connection. Otherwise the allocation is no longer correct and variables cannot communicate in the Runtime!

Connection name

Symbolic connection name. This name is used as a prefix for the variable name.

Communication parameters

Communication parameter

Device type

Selection of the PVI device type from the drop-down list:

  • Serial
  • Ethernet
  • Modem
  • CAN
  • Shared
  • User defined

For types Serial and Ethernet you can open a dialog for configuration by clicking on ....

Device parameters

Direct input of the PVI device parameter. If you carry out the setting for the connection with the configuration dialog for Ethernet or Serial, the settings are overwritten here.

Ethernet default: /IF=TCPIP /SA=1

Serial default: /IF=COM1 /BD=57600 /PA=2 /IT=1

You can find the settings for the single communication types in chapter Device parameter - INA2000 device object

CPU parameters

Direct input of the PVI CPU parameter. This is the station address of the CPU. For serial connections no station address is needed.

Ethernet default: /DA=2

Serial default: -

Routing

Direct input of a routing path for the routing via PLC stations. See description for routing further down.

Save

Saves the configuration of the selected connection.

Cancel

Discards configuration.

OK

Saves all changes and closes dialog.

Cancel

Discards all changes and closes dialog.

info Info

Maximum number of Ethernet connections: 256.

Routing

With the help of routing, communication connections can be established via a PLC station to PLC stations of other networks. This connections can run via several PLC stations. The single stations are defined in the routing path.

Syntax

<Entry 1>/<Entry 2>/.../<Entry n>
The single path entries are separated by character '/'.

Syntax for an entry:

SL<Slot>.SS<Subslot>.IF<Interface>.<Address>

All partial entries are separated by character '.'. Statement SL<Slot> and SS<Subslot> need not to be specified for 0 or 1. The statement <Address> is only needed for connections via the network.

Parameters | Description
SL<Slot> | Slot number: 0 (1) - 15.
SS<Subslot> | Subslot number: 1 - 3.
IF<Interface> | Interface number: 1 - 15.
<Address> | Station address: 1 - ff (hexadecimal).

Routing on or via peripheral processors:

Parameters | Description
CP | Main processor.
PP<Slot> | peripheral processor, slot number: 0 (1) - 15.

Examples

/CN=IF3/IF2.7
From the PC to the first PLC, from there via IF3 to the next station (PLC) and then via IF2 to a CAN station with station number 7.

/CN=SL6.IF1
From the PC to the first PLC then on via slot 6 (e.g. IF 050) and IF1

/CN=PP3
From the PC to the first PLC and on to the peripheral processor 3

Ethernet connection

A click on ... in area Device type opens the dialog for the configuration of the Ethernet connection if you have selected Ethernet:

Parameters | Description
Interface | Defines the interface. Mist always be TCP/IP.
Source address | Station number of the source station (own station). Attention! The station number must be unique within the INA2000 network. As default B&R Automation Studio uses station number 1. Thus it can easily happen that the communication to the PLC does not work if station number 1 is used. The highest possible station number is 99 for SG3 and 255 for SG4. See also Configuration file in redundancy operation
Obtain destination address automatically | Obtain destination address automatically: PVI connects to the defined device (IP address or computer name must be set) and determines the station address automatically.
Enter destination address | Enter destination address: Enter the station address of the target system. If Obtain an IP address automatically is activated, a broadcast is carried out in the network in order to find the station.
Obtain an IP address automatically | Obtain an IP address automatically: Carries out a broadcast in the network and tries to find the station with the station address defined at Enter destination address.
Specify an IP address | Define IP address: Enter the IP address of the station.
Specify a host name | Define host name: Enter the host name of the station.
Use Default values | Resets the properties to the default settings.
OK | Applies settings and closes dialog.
Cancel | Discards settings and closes the dialog.

As an alternative you can enter the values in areas Device Parameter, CPU Parameter and Path target system.

Serial connection

A click on ... in area Device type opens the dialog for the configuration of the serial connection if you have selected Serial:

Parameters

Description

Com port

Defines interface.

Default: COM1

Baud rate

Defines baud rate.

Default: 57600

Parity

Defines parity:

  • no
  • odd
  • even

Default: even

Interval timeout (ms)

Defines the interval in milliseconds.

Default: 1

Use Default values

Resets the properties to the default settings.

OK

Applies settings and closes dialog.

Cancel

Discards settings and closes the dialog.

As an alternative you can enter the values in areas Device Parameter, CPU Parameter and Path target system.


INA2000 communication

BURPVI -> Configuration -> Settings in the driver dialog -> Connections -> INA2000 communication

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The driver supports the communication in accordance with the INA2000 protocol.
The INA2000 communication is supported by the following devices:

  • Serial communication
  • CAN communication
  • Ethernet UDP communication
  • Modem communication
  • Profibus FDL communication
  • LS251 communication
  • AR000 communication

Each INA2000 communication possesses a life monitoring. As soon as a connection is established, it is checked each second by exchanging small data packages (ping/pong).

General PLC prerequisites:

The INA2000 communication works limited (services) as of PLC operating system 1.91. To be able to use all services (e.g. upload, download of modules), PLC operating system 2.10 is necessary.

If multimaster abilities or a TCP/IP communication between PC and PLC are necessary, you must use PLC operating systems 2.20 or higher. For a INA2000 event handling via the PLC (PLC monitors data change), a PLC operating system 2.24 or higher is needed.

INA2000 orders are processed in the PLC in the remaining time. To receive suitable response times, a balance time of at least 20% is required. If 20% balance time cannot be guaranteed due to application reasons, longer answer times will occur and therefore the data will be refreshed slower.

Serial communication

The serial communication can only be operated as point-to-point connection (RS232 or RS422).

CAN communication

The CAN communication is used as INA2000 network with a maximum of 32 (extendable to 255) stations. The individual stations are distinguished by the CAN node number.

PC requirements

Please refer to the manufacturers description to find out which CAN card can by used with which Windows system.

PLC requirements

To allow an INA2000 communication via CAN, you must activate CAN communication in Automation Studio. See Automation Studio documentation (Project -> Hardware configuration -> CAN configuration).

Ethernet UDP communication

PC requirements

The TCP/IP protocol must be installed.

PLC requirements

To allow an INA2000 communication via Ethernet, you must activate Ethernet communication in Automation Studio. See Automation Studio documentation (Project -> Hardware configuration -> Ethernet configuration).

For SG4 (i386) the following is true:
The configuration of the IP address and the station number (INA node number) takes place in the Ethernet property dialog of the Automation Studio. No additional modules must be transferred to the PLC.

For SG3 (m68k) the following is true:
For INA2000 communication modules "FBTCPIP.BR" and "TCPIPMGR.BR" must be burned. In addition a data object "TCPIPCFG.DAT" with the corresponding settings must exist.

Use several Ethernet network cards at the PC.

How to make sure that PVI uses the correct network card in order to communicated with the PLC when two or more network cards are available in the PC.

In order for the correct network card to be selected for the PLC communication, the subnet mask must be set correctly. The IP address of the target station (PLC) is linked with the subnet mask with AND; thus the correct network card is found and used for the communication.

Example:

Device parameter: /IF=tcpip /SA=1

CPU parameter /DA=13 /DAIP=172.43.70.13

IPAdr NW1: 172.43.71.12 subnet mask: 255.255.255.0

IPAdr NW2: 172.43.70.12 subnet mask: 255.255.255.0

IPAdr PLC: 172.43.70.13

With this network card two is used for the communication to the PLC. If a DHCP server is configured for a network card, you must know which IP addresses and subnet masks the DHCP server assigns so that you can configure the second network card correctly.

Modem communication

The Modem communication just as the serial communication is a point-to-point connection.

Modem features:

  • Transparency: The modem is accessed only via standard Windows functions. I.e. any modem can be used which can be installed under Windows. The user must only take care about the installation of the modem. He does not need any special knowledge about the modem (AT commands, etc.).
  • Automatic connection reestablishment: An actively established connection (see below) will be monitored constantly. When the connection is lost (e.g. interruption of the phone line, unplugging the modem, turning of the modem), a new connection establishment is tried in periodic intervals. The number of tries and the interval can be engineered.
  • Active connection establishment: The Windows computer establishes a dial connection to the stated phone number and transfers the protocol defined by PVI line on this connection.
  • Passive connection establishment: The Windows computer waits for an incoming call, picks up automatically and establishes a connection. With this operation mode it is for example possible that a PLC itself initiates a connection establishment to a Windows computer via PVI.

PC requirements

The PVI modem device needs Microsoft TAPI version 2.0. This version is already installed at Windows NT 4.0. When using Windows 95 it is necessary that the default TAPI version 1.4 is replaced by a newer version. The most topical Microsoft (www.microsoft.com) version available is version 2.1. To install TAPI version 2.1 under Windows 95, start program "tapi2195.exe" in subfolder "Pvi\SysSetup\Modem". This file is installed via PVI setup option "Modem system components".

The installation of a modem is carried out in Windows via control panel -> modem. If the dialog is opened it is possible to add new modems and to change the settings of the modem ("Properties"). The label of the modem in this dialog matches the modem name which must be stated as PVI device parameter (/MO).
The behavior during dialing can be configured under "Control panel -> Phone" (current location, dialing card, etc.).

Profibus FDL communication

Note:

The INA2000 communication via Profibus FDL is only possible on System 2000. External systems are not supported by the PVI!

The settings of the PLC Profibus card (NW100/NW150) and the PC card (5A1104.00-090) can be taken from the PROFIBUS user manual (MASYS2PB-0).

PC requirements

The data exchange with the PC takes place via a 32 KB DPR. For this a free address area must be defined on the PC. On the Profibus card this is set with two hex switches SW1 and SW2 (SW1 = 0; SW2=D). If only one Profibus card is used in the system, jumper BR1 and BR2 must be let open. Additional information can be found in the PROFIBUS user manual.

For this memory to be deallocated on the PC, the memory area must be excluded in the BIOS. On the IPC5000 in the BIOS under "PNP/PCI Configuration" you must exclude either 32 KB (1 Profibus card) or 64 KB (for 2 Profibus cards) starting at basic address D000.

PLC requirements

NW100 or NW150 with revision higher/equal to xx.05.

On the PLC operating system 2.00 or higher is necessary. For the INA2000 communication module "FBPB.BR" must be burnt. The Profibus configuration module is already part of the operating system and can be changed with the help of suitable tools if necessary.

To allow an INA2000 communication via Profibus, you must extended the configuration for the INA2000 Profibus communication in the SYSCONF module.

LS251 communication

PC requirements

With Windows NT/2000/YP the LS251 card is recognized by the operating system automatically after it has been plugged in. In the hardware wizard you can select the corresponding driver under "Pvi\Drivers\Ls251\W2k_xx".

Runtime PLC prerequisites:

On LS251 PLC operating system V2.01 or higher must be installed.

AR000 communication

Communication with AR000 takes place via an Ethernet UDP device and an Ethernet UDP station with local IP address 127.0.0.1.

Connection description for device: "/IF=TcpIp", Connection description for station: "/DAIP=127.0.0.1 /REPO=11160".

PC requirements

The AR000 Runtime emulation must be installed.


Device parameter - INA2000 device object

BURPVI -> Configuration -> Settings in the driver dialog -> Connections -> Device parameter - INA2000 device object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

With the INA2000 device object the used communication device is defined. You must enter the parameters described here in the connection configuration in field Device parameter.
The following communication parameters can be defined:

  • Serial device
  • CAN device
  • Ethernet UDP device
  • Modem device
  • Profibus FDL device
  • LS251 device

The communication device including the necessary device parameters are defined in the connection description of the device object. Within the connection description the single parameters are distinguished by parameter identifications. The parameter identification always starts with character '/'.

Syntax of the connection description

/IF=<device name> [/<identification1>=<parameter value> [/<identification2>=<parameter value> ... ]]

Parameter /IF is the same for all communication devices. All other parameters depend on the used communication device. The device name is not case-sensitive. You must insert at least one space character between the parameter declaration.

In the object description the connection description must always be between quotation marks ("...").

Example for connection description

CD="/IF=com1 /BD=57600 /PA=2"

Serial device

The following table shows all definable parameters defined in the connection description of the device object for serial communication.

Parameters

Values

Input

Description

/IF

com1 ...comX

None

Default: com1 to com4. With corresponding serial interface cards or adapters even more than com4 is possible.

Example: "/IF=com1".

/BD

9600,
19200,
38400,
57600,
115200

57600

Baud rate in bits per second.

/RS

-1, 0,
232,
422,
485

232

set protocol RS232 or RS422. RS485 is not supported by INA2000.

Example: "/RS=422".

With this parameter the flow control of the line CTS (clear-to-send)) and RTS (request-to-send) of the serial interface is set.

Possible parameter values:

= -1: PVI does not change the current setting (see properties interface device) of the CTS/RTS flow control.
= 0: always switch off RTS line (RTS flow control is deactivated).
= 232: Use RTS handshake.
= 422: Always switch on RTS line.
= 485: Switch on RTS line in order to trigger a transfer and during a transfer.

The CTS flow control is deactivated for all parameters >= 0.

Some USB/serial adapter (USB to serial interface) cannot handle the CTS/RTS flow control correctly. To establish an RS232 connection via these adapters, parameter "/RS=0" must be entered.

/PA

0 - 4

1

Setting for parity.

0=NOPARITY,
1=ODDPARITY,
2=EVENPARITY,
3=MARKPARITY,
4=SPACEPARITY.

Default setting for INA2000 communication is "/PA=2".

Example Example

Example for connection description:

CD="/IF=com2 /BD=115200 /PA=2"

CAN device

To communicate with a INACAN device, you must first set it up as CAN device via B&R device configuration. The configuration is started via control panel and CAN device. The device list of the configuration shows all already setup CAN devices. The device number must also be entered in the PVI device name. At this device CAN1 matches the PVI device name INACAN1; CAN2 matches INACAN2 and so on. With the B&R CAN device configuration you also set the device resources (IRQ, port address, etc.).

The following table shows all definable parameters defined in the connection description of the device object for CAN communication.

Parameters

Values

Input

Description

/IF

inacan1 ... inacanX

None

CAN device. The used device must be entered in the device list of the B&R CAN device configuration.

Example: "/IF=inacan1".

/CNO

0, 1

0

Number (channel) of the CAN controller.

On the LS172 card 2 CAN controllers are available. With parameter /CNO the desired controller is selected. For the standard CAN controller you must not enter another values as 0 (zero).

Example for LS172 card:

CAN-Bus 1: "/IF=inacan2 /CNO=0",
CAN-Bus 2: "/IF=inacan2 /CNO=1".

/IT

0 - 60000,
0 = off

0

Interval timeout (ms).

Defines the maximum time which may pass between receiving and sending an INA frame between two CAN messages. This parameter is used together with parameter /RT of the INA2000 CPU objects in order to recognize a connection termination.

The parameter must not be smaller than the reaction time of the control (5 - 30 ms) plus a cushion of at least 25 ms (if there is a high interrupt strain on the PC, it must be respectively higher) but it should be smaller than /RT. If no quick recognition of the connection termination is necessary, the monitoring of the interval timeout can be switched off ("/IT=0").

Example: "/IT=80".

/BI

0 - 2047 /
536870911

1598

Basic CAN-ID of the INA2000 communication.

All stations of the INA2000 network must have the same setting.

Example: "/BI=1598".

/MDA

32 - 255

32

Number of maximally possible INA2000 stations (=highest station number).

All stations of the INA2000 network must have the same setting.

Example: "/MDA=50".

/SA

1 - /MDA

1

Station number of the source station (own station).

The station number must be unique within the INA2000 network.

Example: "/SA=3".

/BD

10000,

20000,

50000,

100000,

125000,

150000,

250000,

500000,

800000,

1000000

*)

Baud rate (data rate) at the CAN bus in bits per second. The rate can also be in Kbits per second.

All stations of the INA2000 network must have the same setting.

Example: "/BD=250000" or "/BD=250".

/CMODE

11, 29

*)

CAN communication with 29 bit identifier (extended frames) or with 11 bit identifier (standard frames).

If 29 bit CAN identifiers (extended frames) are used, 11 bit identifiers cannot be received or sent.

All stations of the INA2000 network must have the same setting.

Example: "/CMODE=29".

/CT

>= 1,

0 = off

*)

Cycle time (in ms); in this time not more than the stated number of CAN messages (parameter /MC) can be sent.

Values < 20 ms make no sense.

Example: "/CT=20".

/MC

>= 1

*)

Maximum number of CAN messages which are sent in the states cycle time (parameter /CT).

Example: "/MC=15".

*) Parameters /BD, /CMODE, /CT and /MC can also be set with the B&R CAN device configuration. If these parameters are not stated in the connection description (= recommended method), the values set in the configuration are used. If one of the parameters is stated in the connection description, the respective configuration setting is overwritten.

Parameters /CT and /MC serve as message limitation. With this the number of sent CAN messages per cycle time can be limited. The traffic caused by the PC on the CAN bus is reduced by this. The message limitation is important if other bus members can only process a certain number of received CAN messages at a fixed baud rate or reduce the interrupt strain of other bus members in general. The disadvantage of the message limitation is a slower CAN communication.

For the INA2000 communication each station needs 3 CAN-IDs. The CAN-IDs are created from the basic CAN-ID (parameter /BI), the station number (node number) and the maximum number of stations (parameter /MDA):

  • ID1 (initiate request) = <Basic CAN-ID> + <station number> - 1
  • ID2 (initiate response) = <Basic CAN ID> + <station number> - 1 + <maximum number of stations> * 2
  • ID3 (data segment) = <Basic CAN ID> + <station number> - 1 + <maximum number of stations>

Example Example

Example for connection description:

CD="/IF=inacan3 /CNO=1 /SA=3"

Ethernet UDP device

The following table shows all definable parameters defined in the connection description of the device object for Ethernet UDP communication.

Parameters | Values | Input | Description
/IF | tcpip | None | Ethernet UDP device. Statement: "/IF=tcpip".
/LOPO | 1024 - 32767 | 11159 | Port number of the source station (own station). If the value is stated in hexadecimal, "0x" must be placed in front (e.g. "/LOPO=0x2b97"). You must only set another port number as the default if it is not unique within the local computer. Example: "/LOPO=11159".
/SA | 0 - 99 / 255 | 1 | Station number of the source station (own station). The station number must be unique within the INA2000 network. The highest possible station number is 99 for SG3 and 255 for SG4. Example: "/SA=3".

Example Example

Example for connection description:

CD="/IF=tcpip /SA=3"

Modem device

The following table shows all definable parameters defined in the connection description of the device object for modem communication.

Parameters | Values | Input | Description
/IF | modem1 ... modemX | None | Modem device. Example: "/IF=modem1".
/MO | Modem description | None | Description of the modem as in the setup dialog (control panel -> modem). The string must be between single quotation marks. If a single quotation mark should be used within a string, you must use two single quotation marks (e.g. m'56k is stated as /MO=''56k'). Example: "/MO='MicroLink 56k'".
/TN | Phone number | None | Phone number. The phone number which should be called in accordance with "ITU-T Recommendation E.123", z.B. +43(7748)6586. You must always enter the complete phone number (including international access code); the conversion to the actual phone number is carried out automatically. This string must be between single quotation marks. If it should be waited for a call, you must enter an empty string (/TN="). Example: "/TN='+43(7748)6586'".
/MR | 0 - INFINITE | INFINITE | Maximum number of failed re-dialing attempts. Defines the number of tries a failed connection should be tried to be reestablish. If you enter INFINITE the number of retries is unlimited. If you enter 0, there is no retry. Parameter /MR only has a meaning if /TN is not empty. Examples: "/MR=50", "/MR=INFINITE".
/RI | 0 - 3600 | 60 | Time interval between retries in seconds. If a retry fails, this time is waited until a new try is started. Parameter /RI only has a meaning if /TN is not empty. Example: "/RI=120".
/IT | 0 - 60000 | 40 | Interval timeout (ms). Defines the maximum time which may pass between the reception of two successive characters. Example: "/IT=100".

In addition to parameter /IF, you must also always enter parameter /MO and /TN.

Reading from the serial interface is carried out by an operating system function. A buffer is handed over to this function. In this buffer the received data is stored. The operating system finishes the reading if one of the following situation occurs:

  1. The buffer is full.
  2. Since receiving the last character a time interval which is larger than the timeout interval has past.

The correct setting of parameter /IT for the timeout interval is therefore especially important. If the timeout interval is to small, INA2000 frames could be lost. This would lead to a connection termination. If the timeout interval is to large, the data throughput suffers as the timeout interval passes before the PC recognizes a received frame. Default value 40 ms has been chosen because of measurings which show that a modem (by internal buffering) adds 35 ms breaks in the byte stream. Normally it should not be necessary to select another value. We can however not rule out that you must set a higher value if using another modem type or bad line quality (modems have their own transfer security with automatic retransmission).

Example Example

Example for connection description:

CD="/IF=modem1 /MO='ZyXEL MODEM Omni 288S' /TN='+43(7748)999'"

Profibus FDL device

The following table shows all definable parameters defined in the connection description of the device object for Profibus FDL communication.

Parameters | Values | Input | Description
/IF | pbusfdl1 ... pbusfdlX | None | Profibus device. Example: "/IF=pbusfdl1".
/BA | 0x00000 - 0xFFFFF | 0xD0000 | Basic address of the DPR of the Profibus card. If the value is stated in hexadecimal, "0x" must be placed in front. Example: "/BA=0xD0000".
/FF | Path name*) | nw_load.bin | Path name of the firmware file for the Profibus card. Example: "/FF=nw.bin".
/FC | Path name*) | nw_pb_32.br | Path name of the network configuration file for the Profibus card. Example: "/FC=nw_pb.br".
/CB | 1 - 255 | 2 | Number of communication buffers of the Profibus card. Example: "/CB=4".
/SA | 0-127 | 1 | Station number of the source station (own station). The station number must be unique within the INA2000 network. Example: "/SA=2".

*) A standard firmware file and configuration file is part of the PVI. If no path is entered, the files must be in the folder of the PVI manager.

Settings such as baud rate and timeout cannot be defined via the device parameters. For this the configuration file must be changed with the right tools.

Example Example

Example for connection description:

CD="/IF=pbusfdl1 /FF=c:\pbconfig\nw_load.bin /FC=c:\pbconfig\nw_pb_32.br /SA=1"

LS251 device

The following table shows all definable parameters defined in the connection description of the device object for LS251 communication.

Parameters | Values | Input | Description
/IF | ls251_1 ... ls251_9 | None | LS251 device. Example: "/IF=ls251_1".

Example Example

Example for connection description:

CD="/IF=ls251_1"


Configuration file in redundant operation

BURPVI -> Configuration -> Settings in the driver dialog -> Configuration file in redundant operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The PVI communication needs a unique station address for each station (PLC or computer) in the INA2000 network. For the zenon redundancy operation this means that the server and the standby need different configuration files. In the configuration file the station address is saved for each connection.
This is how you can created different configuration files for the server and the standby:

  • Set up the driver in the Editor so that the connection is correct.
  • Test the communication at the server in the Runtime.
  • Activate the standby once. At this the standby fetches the whole project including the configuration file from the server. Deactivate the standby.
  • Open the Remote transport configuration in the project properties.

    Internal ID: Configuration file in redundant operation

    Remote transport

    The configuration dialog for the Remote Transport is opened.
    The Remote Transport allows to transport, reload, start and stop a project on a remote computer and to receive the current status.

    Read more in the online manual

    This property is available in VBA (with class name) and in the XML export (without class name) under: ""

  • Select the line which is responsible for the driver files (line 8) and set this line inactive. This setting makes sure that the changes you made at the standby are not overwritten by the file from the server. If you do not make this changes, the standby will fetch the topical configuration file from the server and overwrite its own local file.
  • Transfer this change to the server and reload it or start it again.
  • Start the Windows Explorer at the standby.
  • Go to the Runtime folder of the project and then to folder: \RT\FILES\zenon\custom\drivers. There you can find the driver configuration file. Open the file with the Windows Editor (Notepad).
  • For each connection you can find entry DEVICE_PARAM= in the file. In this entry the station address is saved (/SA=x). Change the station address to an unique station address. Save the changes and close the file.
  • Create a variable in the Editor which has property Only read from standby set. With the help of this variable you can check in the Runtime whether the server and the standby communicate simultaneously with the control.

    Internal ID: Configuration file in redundant operation

    Only read from standby

    Active: The value of the variable is displayed from the standby server.
    Inactive: The value of the variable is displayed from the server.
    (only for hardware drivers)

    Read more in the online manual

    This property is available in VBA (with class name) and in the XML export (without class name) under: ""

attention Attention

Changes in the driver configuration (e.g. changed IP address) in the Editor are now no longer transferred via the Remote Transport to the server and from there to the standby. You must manually take care that the changes are added to the configuration files at the server and the standby.


Creating variables

BURPVI -> Creating variables

This is how you can create variables in the zenon Editor:


Creating variables in the Editor

BURPVI -> Creating variables -> Creating variables in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Variables can be created:

  • as simple variables
  • in arrays
  • as structure variables

Variable dialog

To create a new variable, regardless of which type:

  1. Select the New variable command in the Variables node in the context menu

  2. The dialog for configuring variables is opened
  3. configure the variable
  4. The settings that are possible depends on the type of variables

Property

Description

Name

Distinct name of the variable. If a variable with the same name already exists in the project, no additional variable can be created with this name.

Attention: The # character is not permitted in variable names. If non-permitted characters are used, creation of variables cannot be completed and the Finish button remains inactive.

Drivers

Select the desired driver from the drop-down list.

Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.

Driver object type

Select the appropriate driver object type from the drop-down list.

Data type

Select the desired data type. Click on the ... button to open the selection dialog.

Array settings

Expanded settings for array variables. You can find details in the Arrays chapter.

Addressing options

Expanded settings for arrays and structure variables. You can find details in the respective section.

Automatic element activation

Expanded settings for arrays and structure variables. You can find details in the respective section.

Inheritance from data type

Measuring range, Signal range and Set value are always:

  • derived from the datatype
  • Automatically adapted if the data type is changed

Note for signal range: If a change is made to a data type that does not support the set signal range, the signal range is amended automatically. For example, for a change from INT to SINT, the signal range is changed to 127. The amendment is also carried out if the signal range was not inherited from the data type. In this case, the measuring range must be adapted manually.


Addressing

BURPVI -> Creating variables -> Addressing

Group/Property

Description

Addressing

Internal ID: Addressing

Addressing

Properties for the addressing of the variable.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Net address

Internal ID: Addressing

Net address

Bus address or net address of the variable.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Bus address or net address of the variable.

This address refers to the bus address in the connection configuration of the driver. This defines the PLC, on which the variable resides.

Data block

Internal ID: Addressing

Data block

Number of the datablock.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

For variables of object type Extended data block, enter the datablock number here.

Adjustable from 0 to 4294967295. You can take the exact maximum area for data blocks from the manual of the PLC.

Offset

Internal ID: Addressing

Offset

Offset of the variable.
For linear addressing PLCs: the memory area.
For PLCs with a name resolution: the allocation address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Offset of the variable; the memory address of the variable in the PLC. Adjustable from 0 to 4294967295.

Bit number

Internal ID: Addressing

Bit number

Number of the bit within the defined offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Number of the bit within the configured offset.

Possible entries: 0 ... 65535

Alignment

Internal ID: Addressing

Alignment

Depending on the granularity of the driver the position of the variable within the offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte: High byte of the high word in the doubleword offset.
HiWord-LoByte: Low byte of the high word in the doubleword offset.
LoWord-HiByte: High byte of the low word in the doubleword offset.
LoWord-LoByte: Low byte of the low word in the doubleword offset.

For word variables:
HiWord: High word in the doubleword offset.
LoWord: Low word in the doubleword offset.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

String length

Internal ID: Addressing

String length

Only available for string variables:
Maximum number of characters the variable can contain.
Minimum: 0 characters.
Maximum: 65535 characters.
Default: 5 characters.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Only available for String variables: Maximum number of characters that the variable can take.

PVI Address

Internal ID: Addressing

PVI Address

Address information for the Bernecker und Reiner PVI driver (BURPVI)

More in the online help

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Address information for the B&R PVI driver.

PVI Type (VT)

Internal ID: Addressing

PVI Type (VT)

Variable type in the PLC. The possible values are described in the online manual. By using a deviant data type in zenon a type casting can ensue.

More in the online help

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Variable type.
(List of types see table: PVI variable types.)

PVI Number of Elements (VN)

Internal ID: Addressing

PVI Number of Elements (VN)

Number of elements at field variables.
For multi-dimensional field variables the number of the elements of all field dimensions is quoted (Example: var[10][5] => VN =50).

More in the online help

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Number of elements at field variables. Pre-allocation: VN=1.
For multi-dimensional field variables the number of the elements of all field dimensions is quoted (Example: var[10][5] => VN =50).

PVI Length (VL)

Internal ID: Addressing

PVI Length (VL)

Variable length in bytes.
For single variables the variable length equals the process data length. For field variables the variable length defines the element length.

More in the online help

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Variable length in bytes.
For single variables the variable length equals the process data length. For field variables the variable length defines the element length.

Driver connection

Internal ID: Addressing

Driver connection

Driver-specific properties for the variable.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Position of the variable within the defined offset.

Driver

Internal ID: Addressing

Driver

Driver for the variable. It is selected during the creation of the variable and can be changed here later.

Note: Driver for zenon Logic projects cannot be changed later.

More in the online help

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Selection of the driver

Driver object type

Internal ID: Addressing

Driver object type

Depending on the selected driver on creating a variable the object type has to be selected and can be changed here lateron.
Siemens: datablock, marker, input/output.
Modbus: coil and holding register.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Depending on the employed driver, an object type is selected during the creation of the variable; the type can be changed here later.

Data type

Internal ID: Addressing

Data type

Datatype of the variable; is selected on creating the variable and can be changed here lateron.

ATTENTION: If the datatype is changed all the other properties of the variable have to be checked resp. modified.

Read more in the online manual

This property is available in VBA (with class name) and in the XML export (without class name) under: ""

Data type of the variable. Is selected during the creation of the variable; the type can be changed here later.

ATTENTION: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

attention Attention

Addressing of one-dimensional arrays:

If one-dimensional rays are addressed with a start index <> 0, a comma must be attached to the index. For details see: Documentation B&R.

For example: zenon[3,]

PVI variable type (VT)

Type | Description
i8 | 8 bit integer with sign. Variable length: VL=1. Value area: -128 ... 127.
i16 | 16 bit integer with sign. Variable length: VL=2. Value area: -32768 ... 32767.
i32 | 32 bit integer with sign. Variable length: VL=4. Value area: -2147483648 ... 2147483647.
u8 | 8 bit integer unsigned. Variable length: VL=1. Value area: 0 ... 255.
u16 | 16 bit integer unsigned. Variable length: VL=2. Value area: 0 ... 65535.
u32 | 32 bit integer unsigned. Variable length: VL=4. Value area: 0 ... 4294967295.
f32 | 32 bit floating point (IEEE floating). Variable length: VL=4. Value area: -3.402823466e+38 ... -1.175494351e-38 / +1.175494351e-38 ... +3.402823466e+38.
f64 | 64 bit floating point (IEEE floating). Variable length: VL=8. Value area: -1.7976931348623158e+308 ... -2.2250738585072014e-308 / +2.2250738585072014e-308 ... +1.7976931348623158e+308.
Boolean | Bit variable (flag) mapped on 1 byte. Variable length: VL=1. TRUE = value unequal 0, FALSE = value equal 0.
string | String with 1 byte character size and binary 0 (zero) ending. The length of the string buffer can be defined via the variable length (parameter VL). The length of the string buffer is also the maximum string length. The actual string length defined by the binary zero character. At reading and writing process data with variable type string, take care that the data is only transferred up to and including the zero character. All characters after the zero character are undefined.


Driver objects and datatypes

BURPVI -> Creating variables -> Driver objects and datatypes

Driver objects are areas available in the PLC, such as markers, data blocks etc. Here you can find out which driver objects are provided by the driver and which IEC data types can be assigned to the respective driver objects.


Driver objects

BURPVI -> Creating variables -> Driver objects and datatypes -> Driver objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The following object types are available in this driver:

Driver object type | Channel type | Read / Write | Supported data types | Description
Reading in an interrogation | 36 | R / W | BOOL, SINT, USINT, INT, UINT, DINT, UDINT, REAL, STRING | Read array polling as a whole. For details, see "Block reading of arrays" section.
CPU status | 9 | R | BOOL, SINT, USINT, INT, UINT, DINT, UDINT, REAL, STRING | Status of CPU.
PLC marker | 8 | R / W | UINT,INT | Read data points polling/spontaneously.
Driver variable | 35 | R / W | BOOL, SINT, USINT, INT, UINT, DINT, UDINT, REAL, STRING | Variables for the statistical analysis of communication. Find out more in the chapter about the Driver variables

Block reading of arrays

If many elements of an array change very often, block reading of arrays can offer better performance than communication in the event of a value change. For this simple array variables and structures via driver object type Read in an interrogation can be read as block. A block array is a large variable in zenon that reads a complete block from the PLC. Many individual arrays are therefore read as a single array.

Hint: If only a few elements change in an array, communication in Event Mode usually provides better performance.

The following applies for block reading:

  • The complete array is always polled. Event-controlled communication is not possible.
  • The priority selected must be the same for all elements.
  • The PVI settings VN, VL and VT are only required for writing and ignored during reading. They must be set identically to PLC marker.
  • Settings for import are defined in the Global Settings of the driver configuration.

attention Attention

For block reading, zenon data type and PVI type must be the same.

This means: BOOL -> Boolean works. BOOL -> Boolean does not work.

Event operation

Attention: The defined update times also have an effect on the communication with the control in Event mode.
This means: Events via value change never come more often than defined by the update time for the variable.


Mapping of the data types

BURPVI -> Creating variables -> Driver objects and datatypes -> Mapping of the data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

All variables in zenon are derived from IEC data types. The following table compares the IEC datatypes with the datatypes of the PLC.

PLC | zenon | Data type
BOOL | BOOL | 8
USINT | USINT | 9
SINT | SINT | 10
UINT | UINT | 2
INT | INT | 1
UDINT | UDINT | 4
DINT | DINT | 3
LREAL | LREAL | 6
STRING | STRING | 12

Data type: The property Data type is the internal numerical name of the data type. It is also used for the extended DBF import/export of the variables.


Creating variables by importing

BURPVI -> Creating variables -> Creating variables by importing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Variables can also be imported by importing them. The XML and DBF import is available for every driver.


XML import of variables from another zenon project

BURPVI -> Creating variables -> Creating variables by importing -> XML import of variables from another zenon project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

For the import/export of variables the following is true:

  • The import/export must not be started from the global project.
  • The start takes place via:
    • Context menu of variables or data typ in the project tree
    • or context menu of a variable or a data type
    • or symbol in the symbol bar variables

attention Attention

When importing/overwriting an existing data type, all variables based on the existing data type are changed.

Example:

There is a data type XYZ derived from the type INTwith variables based on this data type. The XML file to be imported also contains a data type with the name XYZ but derived from type STRING. If this data type is imported, the existing data type is overwritten and the type of all variables based on it is adjusted. I.e. the variables are now no longer INT variables, but STRING variables.


DBF Import/Export

BURPVI -> Creating variables -> Creating variables by importing -> DBF Import/Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Data can be exported to and imported from dBase.

Import DBF file

To start the import:

  1. right-click on the variable list
  2. in the drop-down menu of Extended export/import... select the Import dBase command
  3. follow the import assistant

The format of the file is described in the chapter File structure.

info Info

Note:

  • Driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.
  • dBase does not support structures or arrays (complex variables) at import.

Export DBF file

To start the export:

  1. right-click on the variable list
  2. in the drop-down menu of Extended export/import... select the Export dBase command
  3. follow the export assistant

attention Attention

DBF files:

  • must correspond to the 8.3 DOS format for filenames (8 alphanumeric characters for name, 3 character suffix, no spaces)
  • must not have dots (.) in the path name.
    e.g. the path C:\users\John.Smith\test.dbf is invalid.
    Valid: C:\users\JohnSmith\test.dbf
  • must be stored close to the root directory in order to fulfill the limit for file name length including path: maximum 255 characters

The format of the file is described in the chapter File structure.

info Info

dBase does not support structures or arrays (complex variables) at export.

File structure of the dBase export file

The dBaseIV file must have the following structure and contents for variable import and export:

attention Attention

dBase does not support structures or arrays (complex variables) when exporting.

DBF files must:

  • correspond to the 8.3 DOS format for filenames (8 alphanumeric characters for name, 3 character suffix, no spaces)
  • Be stored close to the root directory (Root)

Design

Description | Type | Field size | Comment
KANALNAME | Char | 128 | Variable name. The length can be limited using the MAX_LAENGE entry in project.ini .
KANAL_R | C | 128 | The original name of a variable that is to be replaced by the new name entered under "KANALNAME" (field/column must be entered manually). The length can be limited using the MAX_LAENGE entry in project.ini .
KANAL_D | Log | 1 | The variable is deleted with the 1 entry (field/column has to be created by hand).
TAGNR | C | 128 | Identification. The length can be limited using the MAX_LAENGE entry in project.ini .
EINHEIT | C | 11 | Technical unit
DATENART | C | 3 | Data type (e.g. bit, byte, word, ...) corresponds to the data type.
KANALTYP | C | 3 | Memory area in the PLC (e.g. marker area, data area, ...) corresponds to the driver object type.
HWKANAL | Num | 3 | Bus address
BAUSTEIN | N | 3 | Datablock address (only for variables from the data area of the PLC)
ADRESSE | N | 5 | Offset
BITADR | N | 2 | For bit variables: bit address For byte variables: 0=lower, 8=higher byte For string variables: Length of string (max. 63 characters)
ARRAYSIZE | N | 16 | Number of variables in the array for index variables ATTENTION: Only the first variable is fully available. All others are only available for VBA or the Recipe Group Manager
LES_SCHR | R | 1 | Write-Read-Authorization 0: Not allowed to set value. 1: Allowed to set value.
MIT_ZEIT | R | 1 | time stamp in zenon (only if supported by the driver)
OBJEKT | N | 2 | Driver-specific ID number of the primitive object comprises KANALTYP and DATENART
SIGMIN | Float | 16 | Non-linearized signal - minimum (signal resolution)
SIGMAX | F | 16 | Non-linearized signal - maximum (signal resolution)
ANZMIN | F | 16 | Technical value - minimum (measuring range)
ANZMAX | F | 16 | Technical value - maximum (measuring range)
ANZKOMMA | N | 1 | Number of decimal places for the display of the values (measuring range)
UPDATERATE | F | 19 | Update rate for mathematics variables (in sec, one decimal possible) not used for all other variables
MEMTIEFE | N | 7 | Only for compatibility reasons
HDRATE | F | 19 | HD update rate for historical values (in sec, one decimal possible)
HDTIEFE | N | 7 | HD entry depth for historical values (number)
NACHSORT | R | 1 | HD data as postsorted values
DRRATE | F | 19 | Updating to the output (for zenon DDE server, in [s], one decimal possible)
HYST_PLUS | F | 16 | Positive hysteresis, from measuring range
HYST_MINUS | F | 16 | Negative hysteresis, from measuring range
PRIOR | N | 16 | Priority of the variable
REAMATRIZE | C | 32 | Allocated reaction matrix
ERSATZWERT | F | 16 | Substitute value, from measuring range
SOLLMIN | F | 16 | Minimum for set value actions, from measuring range
SOLLMAX | F | 16 | Maximum for set value actions, from measuring range
VOMSTANDBY | R | 1 | Get value from standby server; the value of the variable is not requested from the server but from the standby-server in redundant networks
RESOURCE | C | 128 | Resource label. Free string for export and display in lists. The length can be limited using the MAX_LAENGE entry in project.ini .
ADJWVBA | R | 1 | Non-linear value adaption: 0: Non-linear value adaption is used 1: non linear value adaption is not used
ADJZENON | C | 128 | Linked VBA macro for reading the variable value for non-linear value adjustment.
ADJWVBA | C | 128 | Linked VBA macro for writing the variable value for non-linear value adjustment.
ZWREMA | N | 16 | Linked counter REMA.
MAXGRAD | N | 16 | Gradient overflow for counter REMA.

attention Attention.

When importing, the driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.

Limit definition

Limit definition for limit values 1 to 4, and status 1 to 4:

Description | Type | Field size | Comment
AKTIV1 | R | 1 | Limit value active (per limit value available)
GRENZWERT1 | F | 20 | Technical value or ID number of a linked variable for a dynamic limit (see VARIABLEx) (if VARIABLEx is 1 and here it is -1, the existing variable linkage is not overwritten)
SCHWWERT1 | F | 16 | Threshold value for limit
HYSTERESE1 | F | 14 | Hysteresis in %
BLINKEN1 | R | 1 | Set blink attribute
BTB1 | R | 1 | Logging in CEL
ALARM1 | R | 1 | Alarm
DRUCKEN1 | R | 1 | Printer output (for CEL or Alarm)
QUITTIER1 | R | 1 | Must be acknowledged
LOESCHE1 | R | 1 | Must be deleted
VARIABLE1 | R | 1 | Dyn. limit value linking the limit is defined by an absolute value (see field GRENZWERTx).
FUNC1 | R | 1 | Function linking
ASK_FUNC1 | R | 1 | With interrogation before execution
FUNC_NR1 | N | 10 | ID number of the linked function (if “-1” is entered here, the existing function is not overwritten during import)
A_GRUPPE1 | N | 10 | Alarm/event group
A_KLASSE1 | N | 10 | Alarm/event class
MIN_MAX1 | C | 3 | Minimum, Maximum
FARBE1 | N | 10 | Color as Windows coding
GRENZTXT1 | C | 66 | Limit value text
A_DELAY1 | N | 10 | Time delay
INVISIBLE1 | R | 1 | Invisible

Expressions in the column "Comment" refer to the expressions used in the dialog boxes for the definition of variables. For more information, see chapter Variable definition.


Import PVI variables from the driver

BURPVI -> Creating variables -> Creating variables by importing -> Import PVI variables from the driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

PVI variables can be imported offline via an OPCS XML file or via the online import of the driver.

At the import the variables are merged with existing ones. The key for this is the variable name.

  • Variable designation
    • The variable name consists of: Connection name.task name/variable name
  • Address information:
    • Address: Task name/variable name
    • Data type: u16
    • Connection allocation: Net address 0

To start the import:

  • select Import variables from driver... from the context menu of the driver

Parameters | Description
Offline Import from B&R OPC Server configuration file | Import via XML file which the BuR OPC server generated.
OPCS file... | Selection of the OPCS XML file. Click on button in order to open the explorer for selecting the OPCS file.
Import to connection | Selection of the connection. A click opens the drop-down list with all available connections. All selected XML variables are connected at the import via the net address with the selected connection
Online import from device | Variables are read online from the control.
Connection | Selection of the connection for the online browse.
Task | Selection of the task which is read out at the online browse.

Variable addressing

The addressing takes place via the properties of the applied PVI variable:

Parameters | Description
Net address Internal ID: Import PVI variables from the driver Net address Bus address or net address of the variable. Minimum: 0. Maximum: 4294967295. Default: 0. Read more in the online manual This property is available in VBA (with class name) and in the XML export (without class name) under: "" | Determines the connection in the driver. Refers to the net address of the connection in the driver configuration dialog.
PVI Name Internal ID: Import PVI variables from the driver PVI Name The name of the PLC variable. The name is created from Task name/variable name. For global variables: Only Variable name: More in the online help This property is available in VBA (with class name) and in the XML export (without class name) under: "" | The name of the PLC variable. The name is created from Task name/variable name.
PVI Type (VT) Internal ID: Import PVI variables from the driver PVI Type (VT) Variable type in the PLC. The possible values are described in the online manual. By using a deviant data type in zenon a type casting can ensue. More in the online help This property is available in VBA (with class name) and in the XML export (without class name) under: "" | Variable type. A compilation of all variable types - see list below.
PVI Number of Elements (VN) Internal ID: Import PVI variables from the driver PVI Number of Elements (VN) Number of elements at field variables. For multi-dimensional field variables the number of the elements of all field dimensions is quoted (Example: var[10][5] => VN =50). More in the online help This property is available in VBA (with class name) and in the XML export (without class name) under: "" | Number of elements at field variables. Pre-allocation: VN=1. For multi-dimensional field variables the number of the elements of all field dimensions is quoted (Example: var[10][5] => VN =50).
PVI Length (VL) Internal ID: Import PVI variables from the driver PVI Length (VL) Variable length in bytes. For single variables the variable length equals the process data length. For field variables the variable length defines the element length. More in the online help This property is available in VBA (with class name) and in the XML export (without class name) under: "" | Variable length in bytes. For single variables the variable length equals the process data length. For field variables the variable length defines the element length. s

Global variables

Global variables can only be used when they are integrated in a task. Therefore global variables are always displayed at the task variables at the online import and also addressed as task variable: Task name/variable name

PVI variable type (VT)

Type | Description
i8 | 8 bit integer with sign. Variable length: VL=1. Value area: -128 ... 127.
i16 | 16 bit integer with sign. Variable length: VL=2. Value area: -32768 ... 32767.
i32 | 32 bit integer with sign. Variable length: VL=4. Value area: -2147483648 ... 2147483647.
u8 | 8 bit integer unsigned. Variable length: VL=1. Value area: 0 ... 255.
u16 | 16 bit integer unsigned. Variable length: VL=2. Value area: 0 ... 65535.
u32 | 32 bit integer unsigned. Variable length: VL=4. Value area: 0 ... 4294967295.
f32 | 32 bit floating point (IEEE floating). Variable length: VL=4. Value area: -3.402823466e+38 ... -1.175494351e-38 / +1.175494351e-38 ... +3.402823466e+38.
f64 | 64 bit floating point (IEEE floating). Variable length: VL=8. Value area: -1.7976931348623158e+308 ... -2.2250738585072014e-308 / +2.2250738585072014e-308 ... +1.7976931348623158e+308.
Boolean | Bit variable (flag) mapped on 1 byte. Variable length: VL=1. TRUE = value unequal 0, FALSE = value equal 0.
string | String with 1 byte character size and binary 0 (zero) ending. The length of the string buffer can be defined via the variable length (parameter VL). The length of the string buffer is also the maximum string length. The actual string length defined by the binary zero character. At reading and writing process data with variable type string, take care that the data is only transferred up to and including the zero character. All characters after the zero character are undefined.


Offline import

BURPVI -> Creating variables -> Creating variables by importing -> Import PVI variables from the driver -> Offline import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Preparations in the automation studio

  1. got to the desired file

  2. select Add Object... in the context menu.
  3. in folder OPC select template New OPC Tag Declaration

  4. assign a file name with extension .opct

  5. open the OPC tag list in Automation Studio

  6. add the variable you want to read out via drag & drop
  7. To be able to import structures and arrays offline too, the items of the structures must be removed.

  8. at compiling the Automation Studio Project creates the OPCS file
  9. the OPCS file is stored in the project folder of the Automation Studio in a subfolder; e.g. \Temp\Objects\Config1\PLC1\AsOPCS.opcs

Import into zenon

  1. select command Import variables from driver from the context menu of the driver
  2. in the import dialog select Offline import from B&R OPC server configuration file
  3. click on PPCS file... and select the OPVS file.

  4. select the connection for which the import should be carried out
  5. confirm the dialog by clicking OK
  6. select the desired variable with the help of a double click or click on button Add (multi-selection is possible)

  7. click on button OK in order to import the variable into zenon
  8. an info box informs you about imported variables, changed variables and errors


Online import

BURPVI -> Creating variables -> Creating variables by importing -> Import PVI variables from the driver -> Online import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The driver also supports, for online import, multidimensional arrays and arrays with a start index <> 0 and creates variables with names that correspond to the original array index.

attention Attention

Addressing of one-dimensional arrays:

If one-dimensional rays are addressed with a start index <> 0, a comma must be attached to the index. For details see: Documentation B&R.

For example: zenon[3,]

For the online import:

  1. select command Import variables from driver from the context menu of the driver
  2. select Online Browse in the import dialog
  3. select the connection type and the desired task

  4. confirm the dialog by clicking OK
  5. select the desired variable with the help of a double click or click on button Add (multi-selection is possible)

  6. click on button OK in order to import the variable into zenon
  7. an info box informs you about imported variables, changed variables and errors


Driver variables

BURPVI -> Creating variables -> Driver variables

The driver kit implements a number of driver variables. These are divided into:

  • Information
  • Configuration
  • Statistics and
  • Error messages

The definitions of the variables defined in the driver kit are available in the import file drvvar.dbf (on the CD in the directory: CD_Drive:/Predefined/Variables) and can be imported from there.

Hint: Variable names must be unique in zenon. If driver variables are to be imported from drvvar.dbf again, the variables that were imported beforehand must be renamed.

info Info

Not every driver supports all driver variants.

For example:

  • Variables for modem information are only supported by modem-compatible drivers
  • Driver variables for the polling cycle only for pure polling drivers
  • Connection-related information such as ErrorMSG only for drivers that only edit one connection at a a time

Information

Name from import | Type | Offset | Description
MainVersion | UINT | 0 | Main version number of the driver.
SubVersion | UINT | 1 | Sub version number of the driver.
BuildVersion | UINT | 29 | Build version number of the driver.
RTMajor | UINT | 49 | zenon main version number
RTMinor | UINT | 50 | zenon sub version number
RTSp | UINT | 51 | zenon service pack number
RTBuild | UINT | 52 | zenon build number
LineStateIdle | BOOL | 24.0 | TRUE, if the modem connection is idle
LineStateOffering | BOOL | 24.1 | TRUE, if a call is received
LineStateAccepted | BOOL | 24.2 | The call is accepted
LineStateDialtone | BOOL | 24.3 | Dialtone recognized
LineStateDialing | BOOL | 24.4 | Dialing active
LineStateRingBack | BOOL | 24.5 | While establishing the connection
LineStateBusy | BOOL | 24.6 | Target station is busy
LineStateSpecialInfo | BOOL | 24.7 | Special status information received
LineStateConnected | BOOL | 24.8 | Connection established
LineStateProceeding | BOOL | 24.9 | Dialing completed
LineStateOnHold | BOOL | 24.10 | Connection in hold
LineStateConferenced | BOOL | 24.11 | Connection in conference mode.
LineStateOnHoldPendConf | BOOL | 24.12 | Connection in hold for conference
LineStateOnHoldPendTransfer | BOOL | 24.13 | Connection in hold for transfer
LineStateDisconnected | BOOL | 24.14 | Connection stopped
LineStateUnknow | BOOL | 24.15 | Connection status unknown
ModemStatus | UDINT | 24 | Current modem status
TreiberStop | BOOL | 28 | Driver stopped For driver stop, the variable has the value TRUE and an OFF bit. After the driver has started, the variable has the value FALSE and no OFF bit.
SimulRTState | UDINT | 60 | Informs the status of Runtime for driver simulation.

Configuration

Name from import | Type | Offset | Description
ReconnectInRead | BOOL | 27 | If TRUE, the modem is automatically reconnected for reading
ApplyCom | BOOL | 36 | Apply changes in the settings of the serial interface. Writing to this variable immediately results in the method SrvDrvVarApplyCom being called (which currently has no further function).
ApplyModem | BOOL | 37 | Apply changes in the settings of the modem. Writing this variable immediately calls the method SrvDrvVarApplyModem. This closes the current connection and opens a new one according to the settings PhoneNumberSet and ModemHwAdrSet.
PhoneNumberSet | STRING | 38 | Telephone number, that should be used
ModemHwAdrSet | DINT | 39 | Hardware address for the telephone number
GlobalUpdate | UDINT | 3 | Update time in milliseconds (ms).
BGlobalUpdaten | BOOL | 4 | TRUE, if update time is global
TreiberSimul | BOOL | 5 | TRUE, if driver in sin simulation mode
TreiberProzab | BOOL | 6 | TRUE, if the variables update list should be kept in the memory
ModemActive | BOOL | 7 | TRUE, if the modem is active for the driver
Device | STRING | 8 | Name of the serial interface or name of the modem
ComPort | UINT | 9 | Number of the serial interface.
Baud rate | UDINT | 10 | Baud rate of the serial interface.
Parity | SINT | 11 | Parity of the serial interface
ByteSize | SINT | 14 | Number of bits per character of the serial interface Value = 0 if the driver cannot establish any serial connection.
StopBit | SINT | 13 | Number of stop bits of the serial interface.
Autoconnect | BOOL | 16 | TRUE, if the modem connection should be established automatically for reading/writing
PhoneNumber | STRING | 17 | Current telephone number
ModemHwAdr | DINT | 21 | Hardware address of current telephone number
RxIdleTime | UINT | 18 | Modem is disconnected, if no data transfer occurs for this time in seconds (s)
WriteTimeout | UDINT | 19 | Maximum write duration for a modem connection in milliseconds (ms).
RingCountSet | UDINT | 20 | Number of ringing tones before a call is accepted
ReCallIdleTime | UINT | 53 | Waiting time between calls in seconds (s).
ConnectTimeout | UDINT | 54 | Time in seconds (s) to establish a connection.

Statistics

Name from import | Type | Offset | Description
MaxWriteTime | UDINT | 31 | The longest time in milliseconds (ms) that is required for writing.
MinWriteTime | UDINT | 32 | The shortest time in milliseconds (ms) that is required for writing.
MaxBlkReadTime | UDINT | 40 | Longest time in milliseconds (ms) that is required to read a data block.
MinBlkReadTime | UDINT | 41 | Shortest time in milliseconds (ms) that is required to read a data block.
WriteErrorCount | UDINT | 33 | Number of writing errors
ReadSucceedCount | UDINT | 35 | Number of successful reading attempts
MaxCycleTime | UDINT | 22 | Longest time in milliseconds (ms) required to read all requested data.
MinCycleTime | UDINT | 23 | Shortest time in milliseconds (ms) required to read all requested data.
WriteCount | UDINT | 26 | Number of writing attempts
ReadErrorCount | UDINT | 34 | Number of reading errors
MaxUpdateTimeNormal | UDINT | 56 | Time since the last update of the priority group Normal in milliseconds (ms).
MaxUpdateTimeHigher | UDINT | 57 | Time since the last update of the priority group Higher in milliseconds (ms).
MaxUpdateTimeHigh | UDINT | 58 | Time since the last update of the priority group High in milliseconds (ms).
MaxUpdateTimeHighest | UDINT | 59 | Time since the last update of the priority group Highest in milliseconds (ms).
PokeFinish | BOOL | 55 | Goes to 1 for a query, if all current pokes were executed

Error messages

Name from import | Type | Offset | Description
ErrorTimeDW | UDINT | 2 | Time (in seconds since 1.1.1970), when the last error occurred.
ErrorTimeS | STRING | 2 | Time (in seconds since 1.1.1970), when the last error occurred.
RdErrPrimObj | UDINT | 42 | Number of the PrimObject, when the last reading error occurred.
RdErrStationsName | STRING | 43 | Name of the station, when the last reading error occurred.
RdErrBlockCount | UINT | 44 | Number of blocks to read when the last reading error occurred.
RdErrHwAdresse | UDINT | 45 | Hardware address when the last reading error occurred.
RdErrDatablockNo | UDINT | 46 | Block number when the last reading error occurred.
RdErrMarkerNo | UDINT | 47 | Marker number when the last reading error occurred.
RdErrSize | UDINT | 48 | Block size when the last reading error occurred.
DrvError | SINT | 25 | Error message as number
DrvErrorMsg | STRING | 30 | Error message as text
ErrorFile | STRING | 15 | Name of error log file


Driver-specific functions

BURPVI -> Driver-specific functions

This driver supports the following functions:

  • Block arrays for structures and arrays
  • in online import: Multi-dimensional arrays and arrays with a start index <> 0
  • Blockwrite


Driver commands

BURPVI -> Driver commands

This chapter describes standard functions that are valid for most zenon drivers. Not all functions described here are available for every driver. For example, a driver that does not, according to the data sheet, support a modem connection also does not have any modem functions.

Driver commands are used to influence drivers using zenon; start and stop for example.
The engineering is implemented with the help of function Driver commands. To do this:

  • create a new function
  • select Variables -> Driver commands
  • The dialog for configuration is opened

Parameters

Description

Drivers

Drop-down list with all drivers which are loaded in the project.

Current state

Fixed entry which has no function in the current version.

Driver commands

Drop-down list for the selection of the command.
  • Start driver (online mode)

Driver is reinitialized and started.
  • Stop driver (offline mode)

Driver is stopped. No new data is accepted.

Note: If the driver is in offline mode, all variables that were created for this driver receive the status switched off (OFF; Bit 20).

  • Driver in simulation mode

Driver is set into simulation mode.
The values of all variables of the driver are simulated by the driver. No values from the connected hardware (e.g. PLC, bus system, ...) are displayed.
  • Driver in hardware mode

Driver is set into hardware mode.
For the variables of the driver the values from the connected hardware (e.g. PLC, bus system, ...) are displayed.
  • Driver-specific command

Enter driver-specific commands. Opens input field in order to enter a command.
  • Activate driver write set value

Write set value to a driver is allowed.
  • Deactivate driver write set value

Write set value to a driver is prohibited.
  • Establish connection with modem

Establish connection (for modem drivers) Opens the input fields for the hardware address and for the telephone number.
  • Disconnect from modem

Terminate connection (for modem drivers)

Show this dialog in the Runtime

The dialog is shown in Runtime so that changes can be made.

Driver commands in the network

If the computer, on which the driver command function is executed, is part of the zenon network, additional actions are carried out. A special network command is sent from the computer to the project server, which then executes the desired action on its driver. In addition, the Server sends the same driver command to the project standby. The standby also carries out the action on its driver.

This makes sure that Server and Standby are synchronized. This only works if the Server and the Standby both have a working and independent connection to the hardware.


Error analysis

BURPVI -> Error analysis

Should there be communication problems, this chapter will assist you in finding out the error.


Analysis tool

BURPVI -> Error analysis -> Analysis tool

All zenon modules such as Editor, Runtime, drivers, etc. write messages to a joint log file. To display them correctly and clearly, use the Diagnosis Viewer program that was also installed with zenon. You can find it under Start/All programs/zenon/Tools 7.00 -> Diagviewer.

zenon driver log all errors in the log files. The default folder for the log files is subfolder LOG in directory ProgramData, example: C:\ProgramData\zenon \zenon700\LOG for zenon version 7.00 SP0. Log files are text files with a special structure.

Attention: With the default settings, a driver only logs error information. With the Diagnosis Viewer you can enhance the diagnosis level for most of the drivers to "Debug" and "Deep Debug". With this the driver also logs all other important tasks and events.

In the Diagnosis Viewer you can also:

  • follow currently created entries live
  • customize the logging settings
  • change the folder in which the log files are saved

Hints:

  1. In Windows CE even errors are not logged per default due to performance reasons.
  2. The Diagnosis Viewer displays all entries in UTC (coordinated world time) and not in local time.
  3. The Diagnosis Viewer does not display all columns of a log file per default. To display more columns activate property Add all columns with entry in the context menu of the column header.
  4. If you only use Error logging, the problem description is in column Error text. For other diagnosis level the description is in column General text.
  5. For communication problems many drivers also log error numbers which the PLC assigns to them. They are displayed in Error text and/or Error code and/or Driver error parameter(1 and 2). Hints on the meaning of error codes can be found in the driver documentation and the protocol/PLC description.
  6. At the end of your test set back the diagnosis level from Debug or Deep Debug. At Debug and Deep Debug there are a great deal of data for logging which are saved to the hard drive and which can influence your system performance. They are still logged even after you close the Diagnosis Viewer.

info Info

You can find further information on the Diagnosis Viewer in the Diagnose Viewer chapter.


Check list

BURPVI -> Error analysis -> Check list

Checks after communication errors:

  • Is the PLC connected to the power supply?
  • Are the participants available in the TCP/IP network?
  • Can the PLC be reached via the Ping command?
  • Can the PLC be reached at the respective port via TELNET?
  • Are the PLC and the PC connected with the right cable?
  • Did you select the right COM port?
  • Do the communication parameters match (Baud rate, parity, start/stop bits, ...)?
  • Is the COM port blocked by another application?
  • Did you configure the net address correctly, both in the driver dialog and in the address properties of the variables?
  • Did you use the right object type for the variable?
  • Does the offset addressing of the variable match the one in the PLC?
  • Analysis with the Diagnosis Viewer: Which messages are displayed?


Error messages

BURPVI -> Error analysis -> Error messages

Errors are documented in the output window or in the log file of the Diagnosis Viewer:

Entry | Debug Level | Meaning
Block array item XY: Array index [Index] exceeds actual dimenstions [Limit]. | ERROR | Given index (Address) overwrites the actual array limits.
Block array item XY: Incompatible data types. (Data type size [Zahl] differs from actual data type size [Zahl]) | ERROR | zenon data types do not correspond to PVI type.
Block item XY: Offset '%u' exceeds actual size of the object '%u'. | ERROR | Given index (Address) overwrites the actual array/structure limits.
Block item XY: Incompatible data types. (Data type size [Typel] differs from actual data type size [Type]) | ERROR | zenon data types do not correspond to PVI type.
Block item XY: Struct element [Index] does not exist. | ERROR | Indicated structure element (address) does not exist.